/* 
 * Copyright (C) 2002 TransDimension, Inc. All Rights Reserved
 * Name: os.h
 * Author: Biao Jia		7/01/01
 * Description:
 *    Define os specific operations as macros so that the driver can be used
 *    on differenct os.
 */
#ifndef OS_H
#define OS_H

#include <linux/init.h>
#include <linux/kmod.h>
#include <linux/module.h>
#include <linux/usbdevice_fs.h>
#include <linux/input.h>
#include <linux/delay.h>
#include <asm/unaligned.h>
#include <linux/signal.h>
#include <linux/interrupt.h>
#if 0 // TODO: fix devfs
#include <linux/devfs_fs_kernel.h>
#endif
#include <linux/lp.h>
#include <linux/poll.h>
#include <linux/slab.h>
#include <linux/ioport.h>
#include <asm/uaccess.h>
#include <asm/io.h>
#include <asm/irq.h>
#include <asm/system.h>
#include <asm/current.h>
#include <linux/smp_lock.h>

#include "os_types.h"
#include "os_alloc.h"
#include "os_mem.h"
#include "os_task.h"
#include "os_intr.h"
#include "os_time.h"
#include "os_list.h"
#include "os_sema.h"

#endif /* #ifndef OS_H */
