/*------------------------------------------------------------------------------
File Name        : os_alloc.h
File Description : This file contains the prototypes needed to do storage
                   allocation in Linux 2.4. This file holds the USBLink 
                   equivalent of the stdlib functions in ANSI C.
Copyright        : SoftConnex Technologies, 1999-2001, All rights Reserved
------------------------------------------------------------------------------*/
#ifndef _SOFTCONNEX_OS_ALLOC_H_
#define _SOFTCONNEX_OS_ALLOC_H_

static inline PVOID
OS_Malloc(UINT Size)
{
	return kmalloc(Size, GFP_ATOMIC);
#if 0
	/* This ran into a problem with a usb ethernet device. dev_mc_upload
	 * does a spin_lock_bh which puts it into interrupt context. 
	 * dev_mc_upload calls set_multicast_list which results in a usb ctrl 
	 * message to the device. In order to do the ctrl message the otg 
	 * driver has to allocate memory which causes kmalloc to fall over 
	 * with a BUG.
	 */
	return kmalloc(Size, GFP_KERNEL);
#endif
}

static inline void
OS_Free(PVOID Buffer)
{
	kfree(Buffer);
}

/*
SCT_STATUS OS_MemoryPoolNoncachedCreate(UINT Size);
PVOID OS_MallocNoncached(UINT Size, UINT Alignment);
void OS_FreeNoncached(PVOID Buffer);

#ifdef USBLINK_ENABLE_CLEANUP
SCT_STATUS OS_MemoryPoolNoncachedDelete(void);
#endif
*/

#endif  /* _SOFTCONNEX_OS_ALLOC_H_ */
