/*------------------------------------------------------------------------------
$Archive$
$Date: 2006/10/31 17:13:44 $
$Revision: 1.1.1.1 $
Purpose   : This file holds all prototypes and information for to operating
            system specific interrupt functionality.
Copyright : SoftConnex Technologies, 1999-2001, All rights Reserved
------------------------------------------------------------------------------*/
#ifndef _SOFTCONNEX_OS_INTR_H_
#define _SOFTCONNEX_OS_INTR_H_


/* This macro is used in an interrupt service routine for any work that needs
   to be done on first entry into the ISR. */
#define OS_ENTER_ISR()

/* This macro is used to do work that is needed before we leave and ISR. */
#define OS_EXIT_ISR()

#define OS_INTERRUPT_HANDLER_PROTOTYPE(HandlerName, intr_num)  \
	irqreturn_t HandlerName(int intr_num, void *priv)

/*
#define OS_UnhookPCIInterruptVector(Irq)
void OS_HookPCIInterruptVector(UINT Irq, PVOID VectorHandler);
INLINE void OS_AckInterrupt(UINT Irq);
*/

/* NB: Masked macros */
#define OS_HookNonPCIInterruptVector(Irq, Handler, Data) \
	request_irq(Irq, Handler, IRQF_SHARED | IRQF_TRIGGER_RISING, "otg243", Data)

#define OS_UnhookNonPCIInterruptVector(Irq, Data)		free_irq(Irq, Data)

/* NB: Was save_flags(flags); cli(); -- restore_flags(flags) */
#define OS_DisableInterrupts(Flags)		local_irq_save(flags);
#define OS_EnableInterrupts(Flags)		local_irq_restore(flags);

#endif  /* _SOFTCONNEX_OS_INTR_H_ */
