/*------------------------------------------------------------------------------
$Archive$
$Date: 2006/10/31 17:13:44 $
$Revision: 1.1.1.1 $
Purpose   : This file contains the Semaphore library abstraction for USBLink.
Copyright : SoftConnex Technologies, 1999-2001, All rights Reserved
------------------------------------------------------------------------------*/
#ifndef _SOFTCONNEX_OS_SEMA_H_
#define _SOFTCONNEX_OS_SEMA_H_

/*
#define SC_SEMA_WAIT_FOREVER  WAIT_FOREVER

typedef SEM_ID SCT_SEMAPHORE;

SCT_SEMAPHORE OS_SemaphoreCreate(void);
SCT_STATUS OS_SemaphoreDelete(SCT_SEMAPHORE Semaphore);
SCT_STATUS OS_SemaphoreSignal(SCT_SEMAPHORE Semaphore);
SCT_STATUS OS_SemaphoreWait(SCT_SEMAPHORE Semaphore, UINT TimeoutMS);
*/
#include <linux/version.h>

#if LINUX_VERSION_CODE < KERNEL_VERSION(2,4,9)
#define OS_CompletionCreate(Semaphore)	DECLARE_MUTEX_LOCKED(Semaphore)
#else
#define OS_CompletionCreate(Semaphore)	DECLARE_COMPLETION(Semaphore)
#endif

#if LINUX_VERSION_CODE < KERNEL_VERSION(2,4,9)
#define OS_CompletionWait(Semaphore)	down(Semaphore)
#else
#define OS_CompletionWait(Semaphore)	wait_for_completion(Semaphore)
#endif

#if LINUX_VERSION_CODE < KERNEL_VERSION(2,4,9)
#define OS_CompletionSignal(Semaphore, Status)	up_and_exit(Semaphore, Status)
#else
#define OS_CompletionSignal(Semaphore, Status)	complete_and_exit(Semaphore, Status)
#endif

#define	OS_WaitQueueDeclare(Name)		DECLARE_WAIT_QUEUE_HEAD(Name)
#define	OS_WaitQueueWakeup(Name)		wake_up(Name)
#define	OS_WaitQueueSleep(Name)			interruptible_sleep_on(Name)

#endif  /* _SOFTCONNEX_OS_SEMA_H_ */
