/*------------------------------------------------------------------------------
$Archive$
$Date: 2006/10/31 17:13:44 $
$Revision: 1.1.1.1 $
Purpose   : This file contains the prototypes for the OS specific time
            functions.
Copyright : SoftConnex Technologies, 1999-2001, All rights Reserved
------------------------------------------------------------------------------*/
#ifndef _SOFTCONNEX_OS_TIME_H_
#define _SOFTCONNEX_OS_TIME_H_


#define OS_Wait(waitMs)		mdelay(waitMs) //NB: Interruptible or not, msleep??
#define OS_ReadTimeMS()		(jiffies * 1000 / HZ)


#define OS_DeclareTimer(Timer)		struct timer_list Timer
#define OS_StopTimer(Timer)			del_timer(Timer)
#define OS_StartTimer(Timer, Function, Data, Ms)		\
	{	\
	init_timer(Timer);	\
	Timer->function = Function;	\
	Timer->data = (unsigned long)Data;	\
	Timer->expires = jiffies + (Ms * HZ + 999) / 1000;	\
	add_timer(Timer);	\
	}

#define OS_IsTimerExpired(Timer, Expire)		\
	(Timer->expires < (Expire * HZ + 999) / 1000)


#endif  /* _SOFTCONNEX_OS_TIME_H_ */
