/* 
 * Copyright (C) 2002 TransDimension, Inc. All Rights Reserved
 * Name: otg_chip.h
 * Author: Biao Jia		1/21/02
 * Description:
 *    OTG243 simulator function definitions.
 */
/* Simulate an OTG chip */
#ifndef OTG_CHIP_H
#define OTG_CHIP_H

#include "otg_chip_t.h"
#include "otg_sim_device_t.h"

#define otg_chip_PortResume	1
#define otg_chip_PortReset	2

int otg_chip_Init(void);
void otg_chip_Exit(void);
otg_chip_t *otg_chip_GetChip(void);
char *otg_chip_GetRegName(void *addr);
char *otg_chip_GetRegNameByAddr(int addr);
UINT32 otg_chip_GetReg(int reg);
void otg_chip_WriteFcReg(int reg, UINT32 val);
void otg_chip_WriteMem(int addr, UINT8 val);
UINT8 otg_chip_ReadMem(int addr);

int otg_chip_RhPortStatusChange(int port);

typedef void (*ISR)(int, void *, struct pt_regs *);
extern ISR otg_hcd_GetISR(void);
extern otg_t *otg_hcd_GetDevice(void);

#endif /* #ifndef OTG_CHIP_H */
