/* 
 * Copyright (C) 2002 TransDimension, Inc. All Rights Reserved
 * Name: otg_chip_t.h
 * Author: Biao Jia		1/21/02
 * Description:
 *    OTG243 simulator data and macro definitions.
 */
#ifndef OTG_CHIP_TH
#define OTG_CHIP_TH

#define otg_chip_RegBankSize (otg_MemMapSize_c >> 2)
#define otg_chip_EtdBankSize (16 * 8)

#define otg_chip_TokenOUT	0xE1
#define otg_chip_TokenIN	0x69
#define otg_chip_TokenSOF	0xA5
#define otg_chip_TokenSETUP	0x2D
#define otg_chip_TokenDATA0	0xC3
#define otg_chip_TokenDATA1	0x4B
#define otg_chip_TokenACK	0xD2
#define otg_chip_TokenNAK	0x5A
#define otg_chip_TokenSTALL	0x1E
#define otg_chip_TokenPRE	0x3C

#include "otg_sim_device_t.h"

struct otg_chip
{
	UINT32 reg[otg_chip_RegBankSize];
	int mem_addr;
	UINT32 mem[otg_mem_Size_c >> 2];
	UINT32 etd[otg_chip_EtdBankSize];
	int etdPacketDone[16];

	otg_sim_device_t *ports[3];

	struct timer_list timer;
	int timer_fun;
	int timer_arg;
};

typedef struct otg_chip otg_chip_t;

#endif /* #ifndef OTG_CHIP_TH */
