/* 
 * Copyright (C) 2002 TransDimension, Inc. All Rights Reserved
 * Name: otg_config_desc.h
 * Author: Biao Jia		1/21/02
 * Description:
 *    Configuration object function definitions.
 */
#ifndef OTG_CONFIG_DESC_H
#define OTG_CONFIG_DESC_H

#include "otg_fc_t.h"

int otg_config_desc_SetDesc(otg_config_desc_t *config, UINT8 *desc, int tot);

static inline void
otg_config_desc_Init(otg_config_desc_t *desc)
{
	desc->length = 0;
}

static inline int
otg_config_desc_IsSet(otg_config_desc_t *desc)
{
	return desc->length > 0;
}

static inline int
otg_config_desc_GetLength(otg_config_desc_t *desc)
{
	return desc->length;
}

static inline int
otg_config_desc_GetConfiguration(otg_config_desc_t *desc)
{
	return desc->desc[otg_config_desc_bConfigurationValue];
}

static inline UINT8 *
otg_config_desc_GetDesc(otg_config_desc_t *config)
{
	return config->desc;
}

#include "otg_interface_desc.h"

otg_interface_desc_t *
otg_config_desc_GetInterface(otg_config_desc_t *desc, int intf);

static inline int
otg_config_desc_Set(otg_config_desc_t *config, otg_fc_t *fc)
{
	int i;
	int rc;

	for(i = 0; i < config->desc[otg_config_desc_bNumInterfaces]; i++)
	{
		rc = otg_interface_desc_Set(&config->interfaceDesc[i], fc);
		if (rc)
		{
			return rc;
		}
	}

	return 0;
}

static inline otg_ep_desc_t *
otg_config_desc_GetEndpoint(otg_config_desc_t *desc, int ep)
{
	int i;
	otg_ep_desc_t *edp;

	for(i = 0; i < desc->desc[otg_config_desc_bNumInterfaces]; i++)
	{
		edp = otg_interface_desc_GetEndpoint(&desc->interfaceDesc[i], ep);
		if (edp)
		{
			return edp;
		}
	}

	return 0;
}

#endif /* #ifndef OTG_CONFIG_DESC_H */
