/*
 * Copyright (C) 2002 TransDimension, Inc. All Rights Reserved
 * Name: otg_dma.h
 * Author: Biao Jia		1/21/02
 * Description:
 *    OTG243 DMA object function definitions.
 */
#ifndef OTG_DMA_H
#define OTG_DMA_H

#include "otg_dma_t.h"
#include "otg.h"

static inline void
otg_dma_Init(otg_dma_t *dma, otg_t *otg, int channel)
{
	dma->channel = channel;
	dma->otg = otg;
}

static inline void
otg_dma_Reset(otg_dma_t *dma)
{
	/* dma->config;  ??? */
	dma->etd = 0x0000;

	if (dma->channel == 0)
	{
		otg_WriteChipReg(dma->otg, otg_dma_Config0_c, dma->config);
		otg_WriteChipReg(dma->otg, otg_dma_Etd0_c, dma->etd);
	}
	else
	{
		otg_WriteChipReg(dma->otg, otg_dma_Config1_c, dma->config);
		otg_WriteChipReg(dma->otg, otg_dma_Etd1_c, dma->etd);
	}
}

#endif /* #ifndef OTG_DMA_H */
