/* 
 * Copyright (C) 2002 TransDimension, Inc. All Rights Reserved
 * Name: otg_ep_intr_t.h
 * Author: Biao Jia		1/21/02
 * Description:
 *    Endpoint interrupt object data and macro definitions.
 */
#ifndef OTG_EP_INTR_T
#define OTG_EP_INTR_T

#define otg_ep_intr_Status	0xB0
#define otg_ep_intr_Enable	0xB4
#define otg_ep_intr_Clear	0xB8
#define otg_ep_intr_Set		0xBC

#define otg_ep_intr_All						0x00FEF0FE
#define otg_ep_intr_AllEPn					0x0000F0FE
#define otg_ep_intr_EP1						0x00000002
#define otg_ep_intr_EP0In					0x00001000
#define otg_ep_intr_EP0Out					0x00002000
#define otg_ep_intr_Setup					0x00004000
#define otg_ep_intr_SetupOverWritten		0x00008000
#define otg_ep_intr_CTRL1					0x00020000

#define otg_ep_intr_EPn(n)		(otg_ep_intr_EP1 << (n - 1))
#define otg_ep_intr_CTRLn(n)	(otg_ep_intr_CTRL1 << (n - 1))

struct otg_ep_intr
{
	UINT32 status;
	UINT32 enabled;

	struct otg_fc *fc;
};

typedef struct otg_ep_intr otg_ep_intr_t;

#endif /* #ifndef OTG_EP_INTR_T */
