/* 
 * Copyright (C) 2002 TransDimension, Inc. All Rights Reserved
 * Name: otg_ep_t.h
 * Author: Biao Jia		1/21/02
 * Description:
 *    Function side endpoint object data and macro definitions.
 */
#ifndef OTG_EP_T
#define OTG_EP_T

#define otg_ep_Config(n)	((n) * 16 + 0x10)
#define otg_ep_Buffer(n)	((n) * 16 + 0x14)
#define otg_ep_Ctrl(n)		((n) * 16 + 0x18)
#define otg_ep_FillStatus	0xA0
#define otg_ep_FillSet		0xA4
#define otg_ep_FillClear	0xA8

#define otg_ep_ConfigEnable			0x00000001
#define otg_ep_ConfigType			0x00000006
#define otg_ep_ConfigDirection		0x00000008
#define otg_ep_ConfigStall			0x00000010
#define otg_ep_ConfigNewTransfer	0x00000020
#define otg_ep_ConfigMaxPacketSize	0x0000FFC0

#define otg_ep_ConfigTypeBulk		0x00000000
#define otg_ep_ConfigTypeIso0		0x00000002
#define otg_ep_ConfigTypeIso1		0x00000006

#define otg_ep_ConfigMaxPacketSizeLoc	6

#define otg_ep_BufferBuffer			0x0000FFFF
#define otg_ep_BufferYLoc			16

#define otg_ep_CtrlPacketCount		0x0000FFFF
#define otg_ep_CtrlPacketPerBuffer	0x003F0000
#define otg_ep_CtrlLastPacketSize	0xFFC00000
#define otg_ep_CtrlLength0			0x000003FF
#define otg_ep_CtrlLength1			0x03FF0000

#define otg_ep_CtrlNPLoc			16
#define otg_ep_CtrlLPSLoc			22

#define otg_ep_FillStatusBits		0x20002

struct otg_fc;
struct otg_urb;

struct otg_ep
{
	int dataLen; /* length of data in buffer pointed to by dataPtr */
	int dataPos; /* Current transfer position */
	void *dataPtr;

	int addrX;
	int addrY;

	int index;
	UINT8 halted;

	int currentPacket;
	int packetSize;

	otg_ep_desc_t *desc;
	struct otg_fc *fc;
	struct otg_urb *urb;
};

typedef struct otg_ep otg_ep_t;

#endif /* #ifndef OTG_EP_T */
