/* 
 * Copyright (C) 2002 TransDimension, Inc. All Rights Reserved
 * Name: otg_fc_intr_t.h
 * Author: Biao Jia		1/21/02
 * Description:
 *    OTG243 function interrupt object data and macro definitions.
 */
#ifndef OTG_FC_INTR_T
#define OTG_FC_INTR_T

#define otg_fc_intr_Status	0xC0
#define otg_fc_intr_Enable	0xC4
#define otg_fc_intr_Clear	0xC8
#define otg_fc_intr_Set		0xCC

#define otg_fc_intr_All			0x1F
#define otg_fc_intr_BusReset	0x01
#define otg_fc_intr_SOF			0x02
#define otg_fc_intr_SOFLost		0x04
#define otg_fc_intr_Suspend		0x08
#define otg_fc_intr_Resume		0x10

struct otg_fc;

struct otg_fc_intr
{
	UINT32 status;
	UINT32 enabled;

	struct otg_fc *fc;
};

typedef struct otg_fc_intr otg_fc_intr_t;

#endif /* #ifndef OTG_FC_INTR_T */
