/* 
 * Copyright (C) 2002 TransDimension, Inc. All Rights Reserved
 * Name: otg_fc_t.h
 * Author: Biao Jia		1/21/02
 * Description:
 *    OTG243 function controller data and macro definitions.
 */
#ifndef OTG_FC_T
#define OTG_FC_T

#define otg_fc_StateDefault		0
#define otg_fc_StateAddress		1
#define otg_fc_StateConfigured	2

#define otg_fc_Command		0x04
#define otg_fc_StartAddr	0xD0
#define otg_fc_ChipId		0xE0
#define otg_fc_FrameNo		0xE4
#define otg_fc_UnlockReg	0xE8

#define otg_fc_CommandReset			0x00000001
#define otg_fc_CommandSuspend		0x00000004
#define otg_fc_CommandRemoteWakeup	0x00000010
#define otg_fc_CommandToggleReset1	0x00020000

#define otg_fc_ChipIdChipId		0x0082

#define otg_fc_UnlockRegUnlock		0xEB82

#define otg_fc_StartAddrRead	0x8000
#define otg_fc_StartAddrWrite	0xC000

#define otg_fc_MaxEP		7
#define otg_fc_MaxConfig	2

#define otg_fc_ErrorHnpNotSupported		-1
#define otg_fc_ErrorAltHnpSupported		-2
#define otg_fc_ErrorFunctionOnly		-3
#define otg_fc_ErrorNoFunctionDevice	-4

#include "otg_urb_t.h"
#include "otg_device_desc_t.h"
#include "otg_config_desc_t.h"
#include "otg_str_desc_t.h"
#include "otg_ep0_t.h"
#include "otg_ep_t.h"
#include "otg_fc_intr_t.h"
#include "otg_ep_intr_t.h"

struct otg_fc
{
	int state;
	int started;

	otg_device_desc_t deviceDesc;
	otg_config_desc_t configDesc[otg_fc_MaxConfig];
	UINT8 *otherDesc;
	otg_str_desc_t strDesc;

	otg_config_desc_t *selectedConfig;
	int numConfigs;

	otg_fc_intr_t fcIntr;
	otg_ep_intr_t epIntr;

	otg_ep0_t ep0;
	otg_ep_t ep[otg_fc_MaxEP];

	int start;
	struct otg_mem mem;
	OS_DeclareTimer(timer);
	int timerSet;

	struct otg *otg;
};

typedef struct otg_fc otg_fc_t;

#endif /* #ifndef OTG_FC_T */
