/* 
 * Copyright (C) 2002 TransDimension, Inc. All Rights Reserved
 * Name: otg_hc_etd_t.h
 * Author: Biao Jia		1/21/02
 * Description:
 *    Host ETD bank object data and macro definitions.
 */
#ifndef OTG_HC_ETD_T_H
#define OTG_HC_ETD_T_H

#define otg_hc_etd_MaxEtd_c	16	/* number of ETDs supported by OTG HC */

#define otg_hc_etd_IntrStatus_c		0x18
#define otg_hc_etd_IntrEnable_c		0x1C
#define otg_hc_etd_IntrDisable_c	0x20
#define otg_hc_etd_FilledStatus_c	0x28    
#define otg_hc_etd_FilledSet_c		0x2C     
#define otg_hc_etd_FilledClear_c	0x30    
#define otg_hc_etd_EnableSet_c		0x38    
#define otg_hc_etd_EnableClear_c	0x3C    
#define otg_hc_etd_EnableStatus_c	0x40       
#define otg_hc_etd_ImmediateInt_c	0x50     
#define otg_hc_etd_DoneQueue_c		0x54    

#define otg_hc_etd_All_c		0x0000FFFF       
#define otg_hc_etd_AllIntr_c	0xFFFFFFFF       

struct otg_hc;
struct otg_etd;

struct otg_hc_etd
{
	UINT32 intrStatus;
	UINT32 bufferFilledStatus;
	UINT32 enableStatus;

	struct otg_etd *etd[otg_hc_etd_MaxEtd_c]; /* pointers to ETDs */
	struct otg_hc *hc;
};

typedef struct otg_hc_etd otg_hc_etd_t;

#include "otg_etd_t.h"

#endif /* #ifndef OTG_HC_ETD_T_H */
