/* 
 * Copyright (C) 2002 TransDimension, Inc. All Rights Reserved
 * Name: otg_hc_intr_t.h
 * Author: Biao Jia		1/21/02
 * Description:
 *    Host controller interrupt object data and macro definitions.
 */
#ifndef OTG_HC_INTR_T_H
#define OTG_HC_INTR_T_H


#define otg_hc_intr_SO_c	0x00000001	/* Scheduling Overrun*/
#define otg_hc_intr_RDQ_c	0x00000002	/* Readback Done Queue*/
#define otg_hc_intr_SOF_c	0x00000004	/* Start of Frame*/
#define otg_hc_intr_RD_c	0x00000008	/* Resume Detected*/
#define otg_hc_intr_UE_c	0x00000010	/* Unrecoverable Error*/
#define otg_hc_intr_FNO_c	0x00000020	/* Frame Number Overflow*/
#define otg_hc_intr_RHSC_c	0x00000040	/* Root Hub Status Change*/
#define otg_hc_intr_All_c	0x0000007F	/* All interrupts */

#define otg_hc_intr_Status_c	0x0C     
#define otg_hc_intr_Enable_c	0x10    
#define otg_hc_intr_Disable_c	0x14     

#include "uhcTypes.h"

struct otg_hc;

struct otg_hc_intr
{
	UINT32 enabledIntr;
	UINT32 status;
	UINT32 completeIntr;

	struct otg_hc *hc;
};

typedef struct otg_hc_intr otg_hc_intr_t;

#include "otg_hc_t.h"

#endif /* #ifndef OTG_HC_INTR_T_H */
