/* 
 * Copyright (C) 2002 TransDimension, Inc. All Rights Reserved
 * Name: otg_hc_rh_port_t.h
 * Author: Biao Jia		1/21/02
 * Description:
 *    Root hub port object data and macro definitions.
 */
#ifndef OTG_HC_RH_PORT_T_H
#define OTG_HC_RH_PORT_T_H

#define otg_hc_rh_port_Status_CCS_c      0x00000001 /* CurrentConnectStatus ; ClearPortEnable*/
#define otg_hc_rh_port_Status_PES_c      0x00000002 /* PortEnableStatus ; SetPortEnable*/
#define otg_hc_rh_port_Status_PSS_c      0x00000004 /* PortSuspendStatus ; SetPortSuspend*/
#define otg_hc_rh_port_Status_POCI_c     0x00000008 /* PortOverCurrentIndicator ; ClearSuspendStatus*/
#define otg_hc_rh_port_Status_PRS_c      0x00000010 /* PortResetStatus ; SetPortReset*/
#define otg_hc_rh_port_Status_PPS_c      0x00000100 /* PortPowerStatus ; SetPortPower*/
#define otg_hc_rh_port_Status_LSDA_c     0x00000200 /* LowSpeedDeviceAttached ; ClearPortPower*/

/* port status change indicator */
#define otg_hc_rh_port_Status_CSC_c      0x00010000 /* ConnectStatusChange */
#define otg_hc_rh_port_Status_PESC_c     0x00020000 /* PortEnableStatusChange*/
#define otg_hc_rh_port_Status_PSSC_c     0x00040000 /* PortSuspendStatusChange*/
#define otg_hc_rh_port_Status_PORTOCIC_c 0x00080000 /* PortOverCurrentIndicatorChange*/
#define otg_hc_rh_port_Status_PRSC_c     0x00100000 /* PortResetStatusChange*/

#define otg_hc_rh_port_StatFirstByte     0x000000ff
#define otg_hc_rh_port_StatSecondByte    0x0000ff00
#define otg_hc_rh_port_StatThirdByte     0x00ff0000
#define otg_hc_rh_port_StatFourthByte    0xff000000

#define otg_hc_rh_port_StatFirstByteLoc_c   0
#define otg_hc_rh_port_StatSecondByteLoc_c  8
#define otg_hc_rh_port_StatThirdByteLoc_c   16
#define otg_hc_rh_port_StatFourthByteLoc_c  24

#define otg_hc_rh_port_Status0_c	0x74     
#define otg_hc_rh_port_Status1_c	0x78     
#define otg_hc_rh_port_Status2_c	0x7c   

#define otg_hc_rh_port_PORT_CONNECTION		0
#define otg_hc_rh_port_PORT_ENABLE			1
#define otg_hc_rh_port_PORT_SUSPEND			2
#define otg_hc_rh_port_PORT_OVER_CURRENT	3
#define otg_hc_rh_port_PORT_RESET			4
#define otg_hc_rh_port_PORT_POWER			8
#define otg_hc_rh_port_PORT_LOW_SPEED		9
#define otg_hc_rh_port_C_PORT_CONNECTION	16
#define otg_hc_rh_port_C_PORT_ENABLE		17
#define otg_hc_rh_port_C_PORT_SUSPEND		18
#define otg_hc_rh_port_C_PORT_OVER_CURRENT	19
#define otg_hc_rh_port_C_PORT_RESET			20

#define otg_hc_rh_port_HNPPort		0

struct otg_hc_rh;
struct otg_hc;

struct otg_hc_rh_port
{
	int indexNo;
	int downStream;
	UINT32 hnpPortStatus;

	struct otg_hc_rh *rh;
	struct otg_hc *hc;
};

typedef struct otg_hc_rh_port otg_hc_rh_port_t;

#endif /* #ifndef OTG_HC_RH_PORT_T_H */
