/* 
 * Copyright (C) 2002 TransDimension, Inc. All Rights Reserved
 * Name: otg_interface_desc_t.h
 * Author: Biao Jia		1/21/02
 * Description:
 *    Interface descriptor object data and macro definitions.
 */
#ifndef OTG_INTERFACE_DESC_T
#define OTG_INTERFACE_DESC_T

#define otg_interface_desc_bLength				0
#define otg_interface_desc_bDescriptorType		1
#define otg_interface_desc_bInterfaceNumber		2
#define otg_interface_desc_bAlternateSetting	3
#define otg_interface_desc_bNumEndpoints		4
#define otg_interface_desc_bInterfaceClass		5
#define otg_interface_desc_bInterfaceSubClass	6
#define otg_interface_desc_bInterfaceProtocol	7
#define otg_interface_desc_iInterface			8

#define otg_interface_desc_Max		9
#define otg_interface_desc_Type		4
#define otg_interface_desc_MaxEP	otg_fc_MaxEP

#include "otg_ep_desc_t.h"

struct otg_interface_desc
{
	UINT8 *desc;
	otg_ep_desc_t epDesc[otg_interface_desc_MaxEP];

	int altSetting;
	int length;
};

typedef struct otg_interface_desc otg_interface_desc_t;

#endif /* #ifndef OTG_INTERFACE_DESC_T */
