/* 
 * Copyright (C) 2002 TransDimension, Inc. All Rights Reserved
 * Name: otg_intr_t.h 
 * Author: Biao Jia		1/21/02
 * Description:
 *    OTG243 chip level interrupt object data and macro definitions.
 */
#ifndef OTG_INTR_T_H
#define OTG_INTR_T_H

/* Chip InterruptStatus, InterruptSet, InterruptEnable, and
 * InterruptClear registers all have the same interrupt pib
 * positions.
 */
#define otg_intr_EOT0_c			0x00008000  /* EOT condition, DMA0 counter=0 */
#define otg_intr_EOT1_c			0x00004000  /* EOT condition, DMA1 counter=0 */
#define otg_intr_BSRPSuccess_c	0x00000800
#define otg_intr_SlaveState_c	0x00000400
#define otg_intr_MasterState_c	0x00000200
#define otg_intr_VBusError_c	0x00000100
#define otg_intr_VBusSRPDetect_c	0x00000080
#define otg_intr_DMSRPDetect_c	0x00000040
#define otg_intr_DPSRPDetect_c	0x00000020
#define otg_intr_BSRPDone_c		0x00000010
#define otg_intr_MnpDone_c		0x00000008   /* MNP completed */
#define otg_intr_IdIsA_c		0x00000004   /* mini-A plug inserted */
#define otg_intr_H_c			0x00000002   /* host generated interrupt */
#define otg_intr_F_c			0x00000001   /* function generation interrupt */
#define otg_intr_All_c			0x0000CFFF   /* all interrupts */
#define otg_intr_HNPAll_c		0x00000FFC

#define otg_intr_Status_c	0x34	/* Chip Interrupt Status */
#define otg_intr_Enable_c	0x38	/* Chip Interrupt Enable */
#define otg_intr_Clear_c	0x3c	/* Chip Interrupt Clear */
#define otg_intr_Set_c		0x40	/* Chip Interrupt Set */

#include "uhcTypes.h"

struct otg;

struct otg_intr
{
	UINT32 status;
	UINT32 enable;

	int intrNo;
	struct otg *otg;
};

typedef struct otg_intr otg_intr_t;


#endif /* #ifndef OTG_INTR_T_H */
