/* 
 * Copyright (C) 2002 TransDimension, Inc. All Rights Reserved
 * Name: otg_io_config.h
 * Author: Biao Jia		1/21/02
 * Description:
 *    OTG IO config object function definitions.
 */
#ifndef OTG_IO_CONFIG_H
#define OTG_IO_CONFIG_H

#include "otg_io_config_t.h"

static inline void
otg_io_config_Init(otg_io_config_t *config, otg_t *otg, int reg)
{
	config->otg = otg;
	config->reg = reg;

#ifdef OPEN_DRAIN_INT
#else
	if (reg == 1)
	{
		config->config = otg_ReadChipReg(otg, otg_io_config_Reg2_c);
		config->config &= ~otg_io_config_Reg2_OpenDrain;
		otg_WriteChipReg(otg, otg_io_config_Reg2_c, config->config);
	}
#endif
}

#endif /* #ifndef OTG_IO_CONFIG_H */
