/* 
 * Copyright (C) 2002 TransDimension, Inc. All Rights Reserved
 * Name: otg_linux.h
 * Author: Biao Jia		1/21/02
 * Description:
 *    OTG243 driver host interface to linux data defintions.
 */
#ifndef OTG_LINUX_H
#define OTG_LINUX_H

/* TransDimension, Inc. OTG243 Host/Function/HNP controller driver
 * Contains confidential information
 * 31Jan02 TDI
 */

#include <linux/pci.h>
#include "uhcTypes.h"
#include "otg.h"

#define MODNAME "otg243"

otg_hc_t *otg_hcd_GetHostController(void);
struct usb_bus *otg_hcd_GetUsbBus(void);

void otg_hcd_giveback_urb(otg_hc_t *otg_hc, struct urb* urb);

#ifdef CONFIG_X86_PCE243
#define CONFIG_PCI
#define OS_FindPciDevice(vendor, device, index, bus, function) \
	pcibios_find_device(vendor, device, index, bus, function)
#define OS_PciConfigInLong(bus, function, offset, ptr) \
	pcibios_read_config_dword(bus, function, offset, ptr)
#define OS_Ioremap(address, size) ioremap(address, size)
#define OS_PciConfigOutLong(bus, function, offset, value) \
    pcibios_write_config_dword(bus, function, offset, value);
#endif

#endif
