/* 
 * Copyright (C) 2002 TransDimension, Inc. All Rights Reserved
 * Name: otg_mem_block.h
 * Author: Biao Jia		1/21/02
 * Description:
 *    OTG243 on chip memory block object function definitions.
 */
#ifndef OTG_MEM_BLOCK_H
#define OTG_MEM_BLOCK_H

#include "otg_mem_block_t.h"

static inline void
otg_mem_block_Init(otg_mem_block_t *block)
{
	block->status = 0;
}

static inline void
otg_mem_block_SetBlocks(otg_mem_block_t *block, int blocks)
{
	block->size = blocks;
}

static inline int
otg_mem_block_GetBlocks(otg_mem_block_t *block)
{
	return block->size;
}

static inline void
otg_mem_block_SetUsed(otg_mem_block_t *block)
{
#ifdef DEBUG_MEM
	info("Setting used block=%p", block);
#endif
	block->status |= otg_mem_block_Used_c;
}

static inline void
otg_mem_block_ClearUsed(otg_mem_block_t *block)
{
#ifdef DEBUG_MEM
	info("Clearing used block=%p", block);
#endif
	block->status &= ~otg_mem_block_Used_c;
}

static inline int
otg_mem_block_GetUsed(otg_mem_block_t *block)
{
	return block->status & otg_mem_block_Used_c;
}

#endif /* #ifndef OTG_MEM_BLOCK_H */
