/* 
 * Copyright (C) 2002 TransDimension, Inc. All Rights Reserved
 * Name: otg_mem_t.h
 * Author: Biao Jia		1/21/02
 * Description:
 *    OTG243 on chip memory object data and macro definitions.
 */
#ifndef OTG_MEM_T_H
#define OTG_MEM_T_H

#define otg_mem_Size_c	4096	/* size of host controller data memory */
#define otg_mem_Start_c	0x00	/* Data memory  */

#define otg_mem_BlockMagnitude_c 4	/* 2^4 = 16 bytes per block */
#define otg_mem_BlockSize_c (1 << 4)

#include "otg_mem_block_t.h"

struct otg_mem
{
	int start;	/* Start address of memory */
	int blocks; /* Number of 16 bytes blocks in memory */

	struct otg_mem_block mem_blocks[otg_mem_Size_c >> otg_mem_BlockMagnitude_c];
};

typedef struct otg_mem otg_mem_t;


#endif /* #ifndef OTG_MEM_T_H */
