/* 
 * Copyright (C) 2002 TransDimension, Inc. All Rights Reserved
 * Name: otg_mode_t.h
 * Author: Biao Jia		1/21/02
 * Description:
 *    OTG243 mode object data and macro definitions.
 */
#ifndef OTG_MODE_T_H
#define OTG_MODE_T_H

/* Masks of hardware mode register, address: 0x00 */
#define otg_mode_Reg_c	0x00

#define otg_mode_Endian_c	0x80000000
#define otg_mode_DAKOLY_c	0x00200000
#define otg_mode_DREQT_c	0x00100000
#define otg_mode_DRQPOL_c	0x00080000
#define otg_mode_DAKPOL_c	0x00040000
#define otg_mode_EOTPOL_c	0x00020000
#define otg_mode_INTPOL_c	0x00010000
#define otg_mode_VBusExt_c	0x00000080
#define otg_mode_DataPuls_c	0x00000020
#define otg_mode_VBusPuls_c	0x00000010
#define otg_mode_ExtPU_c	0x00000008
#define otg_mode_HF_c		0x00000003
#define otg_mode_HFHost_c	0x00000002
#define otg_mode_HFFunc_c	0x00000001
#define otg_mode_HFMNP_c	0x00000000
#define otg_mode_HFSwMNP_c	0x00000003

#include "uhcTypes.h"

struct otg;

struct otg_mode
{
	UINT32 mode;

	struct otg *otg;
};

typedef struct otg_mode otg_mode_t;

#include "otg_t.h"

#endif /* #ifndef OTG_MODE_T_H */
