/* 
 * Copyright (C) 2002 TransDimension, Inc. All Rights Reserved
 * Name: otg_sim_device.h
 * Author: Biao Jia		1/21/02
 * Description:
 *    OTG243 function controller simulator function definitions.
 */
#ifndef OTG_SIM_DEVICE_H
#define OTG_SIM_DEVICE_H

#include "otg_sim_device_t.h"

void otg_sim_device_DoFrame(otg_sim_device_t *dev);
otg_sim_device_t * otg_sim_device_New(void);
void otg_sim_device_Delete(otg_sim_device_t *dev);

#include "otg_chip.h"

static inline UINT32
otg_sim_device_ReadFcReg(int reg)
{
	UINT32 w;

	w = otg_chip_GetReg(otg_FcRegBankStart_c + reg);
#ifdef DEBUG_OTG_CHIP
	info("ReadFcReg: 0x%0x:%s with 0x%0x", otg_FcRegBankStart_c + reg,
		otg_chip_GetRegNameByAddr(otg_FcRegBankStart_c + reg), w);
#endif
	return w;
}

static inline void
otg_sim_device_WriteFcReg(int reg, UINT32 w)
{
#ifdef DEBUG_OTG_CHIP
	info("WriteFcReg: 0x%0x:%s with 0x%0x", otg_FcRegBankStart_c + reg,
		otg_chip_GetRegNameByAddr(otg_FcRegBankStart_c + reg), w);
#endif
	otg_chip_WriteFcReg(reg, w);
}

#endif /* #ifndef OTG_SIM_DEVICE_H */
