/* 
 * Copyright (C) 2002 TransDimension, Inc. All Rights Reserved
 * Name: otg_td_ctrl_t.h
 * Author: Biao Jia		1/21/02
 * Description:
 *    OTG243 TD for ctrl/int/bulk object data and macro definitions.
 */
#ifndef OTG_TD_CTRL_T_H
#define OTG_TD_CTRL_T_H

/* Control,Bulk, Interrupt TD field definitions of dword1-dword4 
 ***************************************************************/ 

#define otg_td_ctrl_RetryDelay_c		0x0000001f /* dword 2 */
#define otg_td_ctrl_Pid_c				0x00030000 /* dword 2 */
#define otg_td_ctrl_Rounding_c			0x00040000 /* dword 2 */
#define otg_td_ctrl_DelayIntr_c			0x00380000 /* dword 2 */
#define otg_td_ctrl_DataToggle_c		0x00c00000 /* dword 2 */
#define otg_td_ctrl_ErrorCount_c		0x0f000000 /* dword 2 */
#define otg_td_ctrl_CompletionCode_c	0xf0000000 /* dword 2 */

/* for interrupt TD, two more fields 
 ***********************************/

#define otg_td_ctrl_PollingInterval_c	0x000000ff
#define otg_td_ctrl_RelPollingPos_c		0x0000ff00

#define otg_td_ctrl_DataToggle0_c		0x00800000
#define otg_td_ctrl_DataToggle1_c		0x00C00000


#define otg_td_ctrl_PacketCount_c		0x0000ffff
#define otg_td_ctrl_LastPacketSize_c	0x007f0000
#define otg_td_ctrl_NumPacketsPerBuff_c	0xff800000

#define otg_td_ctrl_DmaSelEnb_c	0x00030000
#define otg_td_ctrl_DmaEnable_c	0x00020000	/* 1=enable,0=disable */
#define otg_td_ctrl_DmaSelect_c	0x00010000	/* 1=ch1, 0 ch0 */

/* bit location of TD fields 
 ****************************/

#define otg_td_ctrl_RetryDelayLoc_c		0  /* dword 2 */
#define otg_td_ctrl_PidLoc_c			16 /* dword 2 */
#define otg_td_ctrl_RoundingLoc_c		18 /* dword 2 */
#define otg_td_ctrl_DelayIntrLoc_c		19 /* dword 2 */
#define otg_td_ctrl_DataToggleLoc_c		22 /* dword 2 */
#define otg_td_ctrl_ErrorCountLoc_c		24 /* dword 2 */
#define otg_td_ctrl_CompletionCodeLoc_c	28 /* dword 2 */

/* for interrupt TD, two more fields 
 ***********************************/

#define otg_td_ctrl_PollingIntervalLoc_c	0  /* dword 2 */
#define otg_td_ctrl_RelPollingPosLoc_c		8  /* dword 2 */

#define otg_td_ctrl_PacketCountLoc_c		0  /* dword 3 */
#define otg_td_ctrl_LastPacketSizeLoc_c		16 /* dword 3*/
#define otg_td_ctrl_NumPacketsPerBuffLoc_c	23 /* dword 3*/

/* PID values 
 *************/

#define otg_td_ctrl_Pid_Setup_c	0x00000000 /* dword 2 */
#define otg_td_ctrl_Pid_Out_c	0x00010000 /* dword 2 */
#define otg_td_ctrl_Pid_In_c	0x00020000 /* dword 2 */


struct otg_td_ctrl
{
	UINT32 ctrl;
	UINT32 info;
};

typedef struct otg_td_ctrl otg_td_ctrl_t;


#endif /* #ifndef OTG_TD_CTR_T_H */
