/* 
 * Copyright (C) 2002 TransDimension, Inc. All Rights Reserved
 * Name: otg_td_iso_t.h
 * Author: Biao Jia		1/21/02
 * Description:
 *    OTG243 TD for iso object data and macro definitions.
 */
#ifndef OTG_TD_ISO_T_H
#define OTG_TD_ISO_T_H

/* Iso TD field definitions 
 ***************************/

#define otg_td_iso_StartingFrame_c		0x0000ffff       /* dword 2 */
#define otg_td_iso_NumPacketsPerBuff_c	0x00070000       /* dword 2 */
#define otg_td_iso_DelayIntr_c			0x00700000       /* dword 2 */
#define otg_td_iso_FrameCount_c			0x07000000       /* dword 2 */
#define otg_td_iso_LastCompleteCode_c	0xF0000000       /* dword 2 */


/* dword 3-6 contains 8 TD info: 
 * each represents length of buffer N or packet status word N 
 *************************************************************/

#define otg_td_iso_EtdPerPipe		2
#define otg_td_iso_MaxPackets		8
#define otg_td_iso_LowerLenPSW_c	0x00000fff
#define otg_td_iso_UpperLenPSW_c	0x0fff0000

#define otg_td_iso_DmaSelEnb_c          0x60000000
#define otg_td_iso_DmaEnable_c          0x40000000   /* 1=enable,0=disable */
#define otg_td_iso_DmaSelect_c          0x20000000   /* 1=ch1, 0 ch0 */


/* Iso TD PacketStatusWord 
 **************************/

#define otg_td_iso_InSize_c             0x07FF           /* IN bytes */
#define otg_td_iso_CompletionCode_c     0xF000           /* Completion Code */

/* Iso TD fields bit positions */
#define otg_td_iso_StartingFrameLoc_c      0
#define otg_td_iso_NumPacketsPerBuffLoc_c  16
#define otg_td_iso_DelayIntrLoc_c          20
#define otg_td_iso_FrameCountLoc_c         24
#define otg_td_iso_CompletionCodeLoc_c     12
#define otg_td_iso_UpperDwordLoc_c         16
#define otg_td_iso_LowerDwordLoc_c         0

#define otg_td_iso_CCn_NotAccessed_c	(otg_etd_CC_NotAccessed_c >> otg_td_iso_UpperDwordLoc_c)
#define otg_td_iso_CCn_BufferOverRun_c	(otg_etd_CC_BufferOverRun_c >> otg_td_iso_UpperDwordLoc_c)

struct otg_td_iso
{
	UINT32 ctrl;
	UINT32 data[4];
};

typedef struct otg_td_iso otg_td_iso_t;


#endif /* #ifndef OTG_TD_ISO_T_H */
