/* 
 * Copyright (C) 2002 TransDimension, Inc. All Rights Reserved
 * Name: request_host.c
 * Author: Biao Jia		1/21/02
 * Description:
 *    B-device request A-device to transfer host.
 */
#include "os.h"
#include "stack_urb.h"
#include "otg.h"
#include "otg_fd.h"

int otg_function_RequestBus(void);
void otg_function_ReleaseBus(void);

static int __init request_host_init(void)
{
	int rc;

	rc = otg_function_RequestBus();
	if (rc)
	{
		if (rc == otg_fc_ErrorHnpNotSupported)
		{
			err("A device do not support HNP");
		}
		else if (rc == otg_fc_ErrorAltHnpSupported)
		{
			err("A device support HNP on a different port");
		}
		else if (rc == otg_fc_ErrorFunctionOnly)
		{
			err("B device is function only");
		}
		else if (rc == otg_fc_ErrorNoFunctionDevice)
		{
			err("No function device");
		}
		else
		{
			err("Request to be host failed with %d", rc);
		}

		return -1;
	}

	return 0;
}

static void __exit request_host_exit(void)
{
	otg_function_ReleaseBus();
}

module_init(request_host_init);
module_exit(request_host_exit);
