/* 
 * Copyright (C) 2002 TransDimension, Inc. All Rights Reserved
 * Name: sa1100_accelent.h
 * Author: Biao Jia		7/12/02
 * Description:
 *    SA1100 accelent specific operations.
 */
#ifndef SA1100_ACCELENT_H
#define SA1100_ACCELENT_H

/* #define OTG_BIG_ENDIAN				1 */
#undef OTG_BIG_ENDIAN
#define OTG_DMA_DACK_ONLY				1
/* #undef OTG_DMA_DACK_ONLY */
#define OTG_DMA_DACK_ACTIVE_HIGH		1
/* #undef OTG_DMA_DACK_ACTIVE_HIGH */
#define OTG_DMA_DRQ_LEVEL_SENSITIVE		1
/* #undef OTG_DMA_DRQ_LEVEL_SENSITIVE	1 */
#define OTG_DMA_DRQ_ACTIVE_HIGH			1
/* #undef OTG_DMA_DRQ_ACTIVE_HIGH */
#define OTG_DMA_EOT_ACTIVE_HIGH			1
/* #undef OTG_DMA_EOT_ACTIVE_HIGH */
#define OTG_INT_ACTIVE_HIGH			1
/* #undef OTG_INT_ACTIVE_HIGH */
/* #define OTG_VBUS_SOURCE_EXTERNAL		1 */
#undef OTG_VBUS_SOURCE_EXTERNAL
#define OTG_SRP_VBUS_PULSE				1
/* #undef OTG_SRP_VBUS_PULSE */
/* #define OTG_EXTERNAL_PULLUP			1 */
#undef OTG_EXTERNAL_PULLUP
/* #define OTG_HOST_ONLY				1 */
#undef OTG_HOST_ONLY
/* #define OTG_FUNCTION_ONLY			1 */
/* #undef OTG_FUNCTION_ONLY */
#define OTG_HOST_AND_FUNCTION			1
/* #undef OTG_HOST_AND_FUNCTION */

#ifdef CONFIG_SA1100_ACCELENT
#define OTG243_INT_LVL IRQ_GPIO13
#define OTG243_MEM_START 0x43800000
static inline int
RequestIrq
(
	unsigned int irq,
	void (*handler)(int, void *, struct pt_regs *),
	void *otg
)
{
#ifdef DEBUG_OTG_CHIP
printk("request_irq for Accelent\n");
#endif
	GPDR &= ~(GPIO_GPIO(13));
	set_GPIO_IRQ_edge(GPIO_GPIO(13), GPIO_RISING_EDGE);
	return OS_HookNonPCIInterruptVector(irq, handler, otg);
}

static inline void
ModifySpeed(void)
{
	UINT32 msc2;

	msc2 = MSC2 & 0xFFFF0000;
	MSC2 = msc2 | 0x4849;
}
#endif

#endif /* #ifndef SA1100_ACCELENT_H */
