/* 
 * Copyright (C) 2002 TransDimension, Inc. All Rights Reserved
 * Name: sa1100_cerf.h
 * Author: Biao Jia		7/12/02
 * Description:
 *    SA1100 cerfpda specific operations.
 */
#ifndef SA1100_CERF_H
#define SA1100_CERF_H

/* #define OTG_BIG_ENDIAN				1 */
#undef OTG_BIG_ENDIAN
#define OTG_DMA_DACK_ONLY				1
/* #undef OTG_DMA_DACK_ONLY */
#define OTG_DMA_DACK_ACTIVE_HIGH		1
/* #undef OTG_DMA_DACK_ACTIVE_HIGH */
#define OTG_DMA_DRQ_LEVEL_SENSITIVE		1
/* #undef OTG_DMA_DRQ_LEVEL_SENSITIVE	1 */
#define OTG_DMA_DRQ_ACTIVE_HIGH			1
/* #undef OTG_DMA_DRQ_ACTIVE_HIGH */
#define OTG_DMA_EOT_ACTIVE_HIGH			1
/* #undef OTG_DMA_EOT_ACTIVE_HIGH */
#define OTG_INT_ACTIVE_HIGH			1
/* #undef OTG_INT_ACTIVE_HIGH */
/* #define OTG_VBUS_SOURCE_EXTERNAL		1 */
#undef OTG_VBUS_SOURCE_EXTERNAL
#define OTG_SRP_VBUS_PULSE				1
/* #undef OTG_SRP_VBUS_PULSE */
/* #define OTG_EXTERNAL_PULLUP			1 */
#undef OTG_EXTERNAL_PULLUP

#ifdef CONFIG_SA1100_CERF
#define OTG243_INT_LVL IRQ_GPIO14
#define OTG243_MEM_START 0x48000000
#define OTG_16_BIT_DATA_BUS
#define OTG_ADJUST_TIMING

static inline int
RequestIrq
(
	unsigned int irq,
	void (*handler)(int, void *, struct pt_regs *),
	void *otg
)
{
#ifdef DEBUG_OTG_CHIP
printk("request_irq for CERF\n");
#endif
	GPDR &= ~(GPIO_GPIO(14));
	set_GPIO_IRQ_edge(GPIO_GPIO(14), GPIO_RISING_EDGE);
	return OS_HookNonPCIInterruptVector(irq, handler, otg);
}

static inline void
ModifySpeed(void)
{
	UINT32 msc2;

	msc2 = MSC2 & 0x0000FFFF;
	MSC2 = msc2 | 0x4C690000;
}
#endif

#endif /* #ifndef SA1100_CERF_H */
