/* 
 * Copyright (C) 2002 TransDimension, Inc. All Rights Reserved
 * Name: stack_pipe.h
 * Author: Biao Jia		6/25/02
 * Description:
 *    URB adapter. Convert OS specific URB to otg urb.
 */
#ifndef STACK_PIPE_H
#define STACK_PIPE_H

typedef int stack_pipe_t;

/* NB: Taken from 2.4.13 include/usb.h */
#define usb_pipe_endpdev(pipe)	(((pipe) >> 8) & 0x7ff) // Clearly ok

static inline int
stack_pipe_GetAddressEndpoint(stack_pipe_t pipe)
{
	return usb_pipe_endpdev(pipe);
}

static inline int
stack_pipe_IsIn(stack_pipe_t pipe)
{
	return usb_pipein(pipe);
}

static inline int
stack_pipe_IsOut(stack_pipe_t pipe)
{
	return usb_pipeout(pipe);
}

#endif /* #ifndef STACK_PIPE_H */
