/* 
 * Copyright (C) 2002 TransDimension, Inc. All Rights Reserved
 * Name: storage_cbw.c
 * Author: Biao Jia		5/3/02
 * Description:
 *    Mass storage CBW (Command Block Wrapper) handler.
 */

#include "os.h"
#include "stack_urb.h"

#include "uhcTypes.h"
#include "storage_cbw.h"

int
storage_cbw_Load(storage_cbw_t *cbw, UINT8 *buf, int len)
{
	UINT32 *dwp;
	UINT8 *bp;
	int i;

#ifdef DEBUG_OTG_CHIP
info("Load: len=%d", len);
#endif
	if (len != storage_cbw_PacketLength)
	{
		return -1;
	}

	dwp = (UINT32 *)buf;
	cbw->signature = *dwp;
	dwp++;
	cbw->tag = *dwp;
	dwp++;
	cbw->dataTransferLength = *dwp;
	dwp++;
	
	bp = (UINT8 *)dwp;
	cbw->flags = *bp;
	bp++;
	cbw->logicUnitNumber = *bp;
	bp++;
	cbw->commandBlockLength = *bp;
	bp++;
	
	if (cbw->commandBlockLength & ~storage_cbw_CBLength)
	{
		return -1;
	}

	if (cbw->commandBlockLength > storage_cbw_CbMax)
	{
		return -1;
	}

	for(i = 0; i < cbw->commandBlockLength; i++)
	{
		cbw->commandBlock[i] = *bp;
		bp++;
	}

	if (cbw->signature != storage_cbw_Signature)
	{
		return -1;
	}

	if (cbw->logicUnitNumber & ~storage_cbw_Lun)
	{
		return -1;
	}

	if (cbw->logicUnitNumber & storage_cbw_Lun)
	{
		return -1;
	}
#ifdef DEBUG_OTG_CHIP
info("Load: ");
#endif

	return 0;
}
