/* 
 * Copyright (C) 2002 TransDimension, Inc. All Rights Reserved
 * Name: storage_cbw.h
 * Author: Biao Jia		5/1/02
 * Description:
 *    Mass Storage Class CBW object function definitions.
 */
#ifndef STORAGE_CBW_H
#define STORAGE_CBW_H

#include "storage_cbw_t.h"
#include "uhcTypes.h"

int storage_cbw_Load(storage_cbw_t *cbw, UINT8 *buf, int len);

static inline UINT8 *
storage_cbw_GetCommand(storage_cbw_t *cbw)
{
	return cbw->commandBlock;
}

static inline int
storage_cbw_GetCommandLength(storage_cbw_t *cbw)
{
	return cbw->commandBlockLength;
}

static inline int
storage_cbw_GetLength(storage_cbw_t *cbw)
{
	return cbw->dataTransferLength;
}

static inline int
storage_cbw_GetTag(storage_cbw_t *cbw)
{
	return cbw->tag;
}

static inline int
storage_cbw_IsIn(storage_cbw_t *cbw)
{
	return (cbw->flags & storage_cbw_Direction) == storage_cbw_DirectionIn;
}

#endif /* STORAGE_CBW_H */
