/* 
 * Copyright (C) 2002 TransDimension, Inc. All Rights Reserved
 * Name: storage_cbw_t.h
 * Author: Biao Jia		5/1/02
 * Description:
 *    Mass Storage Class CBW object data and macro definitions.
 */

#ifndef STORAGE_CBW_T_H
#define STORAGE_CBW_T_H

#define storage_cbw_Signature			0x43425355
#define storage_cbw_Direction			0x80
#define storage_cbw_Lun					0x0F
#define storage_cbw_CBLength			0x1F

#define storage_cbw_DirectionIn			0x80

#define storage_cbw_PacketLength		31
#define storage_cbw_CbMax				16

struct storage_cbw
{
	UINT32 signature;
	UINT32 tag;
	UINT32 dataTransferLength;
	UINT8 flags;
	UINT8 logicUnitNumber;
	UINT8 commandBlockLength;
	UINT8 commandBlock[storage_cbw_CbMax];
};

typedef struct storage_cbw storage_cbw_t;

#endif /* STORAGE_CBW_T_H */
