/* 
 * Copyright (C) 2002 TransDimension, Inc. All Rights Reserved
 * Name: storage_csw.h
 * Author: Biao Jia		5/1/02
 * Description:
 *    Mass Storage Class CSW object function definitions.
 */
#ifndef STORAGE_CSW_H
#define STORAGE_CSW_H

#include "storage_csw_t.h"

static inline void
storage_csw_AddLength(storage_csw_t *csw, int len)
{
	csw->dataResidue -= len;
}

static inline int
storage_csw_GetLength(storage_csw_t *csw)
{
	return csw->dataResidue;
}

static inline void
storage_csw_SetStatus(storage_csw_t *csw, int status)
{
	csw->status = status;
}

static inline void
storage_csw_SetResidue(storage_csw_t *csw, int len)
{
	csw->dataResidue = len;
}

static inline void
storage_csw_FillUrb(storage_csw_t *csw, otg_urb_t *urb)
{
	memcpy(otg_urb_GetBuffer(urb), csw, storage_csw_PacketLength);
	otg_urb_SetLength(urb, storage_csw_PacketLength);
}

static inline void
storage_csw_Fill(storage_csw_t *csw, storage_cbw_t *cbw)
{
	csw->signature = storage_csw_Signature;
	csw->tag = storage_cbw_GetTag(cbw);
	csw->dataResidue = storage_cbw_GetLength(cbw);
}

#endif /* STORAGE_CSW_H */
