/* 
 * Copyright (C) 2002 TransDimension, Inc. All Rights Reserved
 * Name: uCdimm5272.h
 * Author: Biao Jia		7/12/02
 * Description:
 *    uCdimm5272 specific hardware operation functions.
 */
#ifndef UCDIMM5272_H
#define UCDIMM5272_H

#define OTG_BIG_ENDIAN				1
/* #undef OTG_BIG_ENDIAN */
#define OTG_DMA_DACK_ONLY				1
/* #undef OTG_DMA_DACK_ONLY */
#define OTG_DMA_DACK_ACTIVE_HIGH		1
/* #undef OTG_DMA_DACK_ACTIVE_HIGH */
#define OTG_DMA_DRQ_LEVEL_SENSITIVE		1
/* #undef OTG_DMA_DRQ_LEVEL_SENSITIVE	1 */
#define OTG_DMA_DRQ_ACTIVE_HIGH			1
/* #undef OTG_DMA_DRQ_ACTIVE_HIGH */
#define OTG_DMA_EOT_ACTIVE_HIGH			1
/* #undef OTG_DMA_EOT_ACTIVE_HIGH */
/* #define OTG_INT_ACTIVE_HIGH			1 */
#undef OTG_INT_ACTIVE_HIGH
/* #define OTG_VBUS_SOURCE_EXTERNAL		1 */
#undef OTG_VBUS_SOURCE_EXTERNAL
#define OTG_SRP_VBUS_PULSE				1
/* #undef OTG_SRP_VBUS_PULSE */
/* #define OTG_EXTERNAL_PULLUP			1 */
#undef OTG_EXTERNAL_PULLUP

#ifdef CONFIG_UCDIMM5272
#define OTG243_INT_LVL 66
#define OTG243_MEM_START 0x40000000
#define OTG_16_BIT_DATA_BUS
#define OTG_ADJUST_TIMING
#define OTG_CLEAR_INTR

#include <asm/coldfire.h>
#include <asm/m5272sim.h>

static inline int
RequestIrq
(
	unsigned int irq,
	void (*handler)(int, void *, struct pt_regs *),
	void *otg
)
{
	UINT32 w;
#ifdef DEBUG_OTG_CHIP
printk("request_irq for Coldfire\n");
#endif

	/* Modify ICR1 for INT2. Make it level 3 interrupt */
	w = *(volatile UINT32 *)(MCFSIM_ICR1 + MCF_MBAR);
	w &= 0x70777777;
	w |= 0x0B000000;
	*(volatile UINT32 *)(MCFSIM_ICR1 + MCF_MBAR) = w;
	return OS_HookNonPCIInterruptVector(irq, handler, otg);
}

static inline void
ModifySpeed(void)
{
	UINT32 w;

	w = *(volatile UINT32 *)(MCFSIM_CSOR2 + MCF_MBAR);
	w |= 0xE00; /* Set ASET, WRAH and RDAH */
	*(volatile UINT32 *)(MCFSIM_CSOR2 + MCF_MBAR) = w;
}

static inline void
ClearInterrupt(void)
{
	UINT32 w;

	w = *(volatile UINT32 *)(MCFSIM_ICR1 + MCF_MBAR);
	w &= 0x77777777;
	w |= 0x08000000;
	*(volatile UINT32 *)(MCFSIM_ICR1 + MCF_MBAR) = w;
}
#endif

#endif /* #ifndef UCDIMM5272_H */
