/* 
 * Copyright (C) 2002 TransDimension, Inc. All Rights Reserved
 * Name: x86_adastra.h
 * Author: Michael Posadas	7/18/02
 * Description:
 *    X86 specific operations with PCE243 PCI card
 */
#ifndef X86_PCE243_H
#define X86_PCE243_H

/* #define OTG_BIG_ENDIAN				1 */
#undef OTG_BIG_ENDIAN
#define OTG_DMA_DACK_ONLY				1
/* #undef OTG_DMA_DACK_ONLY */
#define OTG_DMA_DACK_ACTIVE_HIGH		1
/* #undef OTG_DMA_DACK_ACTIVE_HIGH */
#define OTG_DMA_DRQ_LEVEL_SENSITIVE		1
/* #undef OTG_DMA_DRQ_LEVEL_SENSITIVE	1 */
#define OTG_DMA_DRQ_ACTIVE_HIGH			1
/* #undef OTG_DMA_DRQ_ACTIVE_HIGH */
#define OTG_DMA_EOT_ACTIVE_HIGH			1
/* #undef OTG_DMA_EOT_ACTIVE_HIGH */
/* #define OTG_INT_ACTIVE_HIGH			1 */
#undef OTG_INT_ACTIVE_HIGH
/* #define OTG_VBUS_SOURCE_EXTERNAL		1 */
#undef OTG_VBUS_SOURCE_EXTERNAL
#define OTG_SRP_VBUS_PULSE				1
/* #undef OTG_SRP_VBUS_PULSE */
/* #define OTG_EXTERNAL_PULLUP			1 */
#undef OTG_EXTERNAL_PULLUP
/* #define OTG_HOST_ONLY				1 */
#undef OTG_HOST_ONLY
/* #define OTG_FUNCTION_ONLY			1 */
/* #undef OTG_FUNCTION_ONLY */
#define OTG_HOST_AND_FUNCTION			1
/* #undef OTG_HOST_AND_FUNCTION */

/* #define OPEN_DRAIN_INT */
#undef OPEN_DRAIN_INT

#ifdef CONFIG_X86_PCE243
extern int OTG_PCE243_GetInt(void);
extern int OTG_PCE243_GetBase(void);

#define OTG243_INT_LVL OTG_PCE243_GetInt()
#define OTG243_MEM_START OTG_PCE243_GetBase()

#define	RequestIrq(irq, handler, regs) \
	OS_HookNonPCIInterruptVector(irq, handler, regs)
#define PRINT_DEBUGPCI(x) printk(x)

#endif

#endif /* #ifndef X86_PCE243_H */
