/* 
 * Copyright (C) 2002 TransDimension, Inc. All Rights Reserved
 * Name: xscale_cerf.h
 * Author: Biao Jia		7/12/02
 * Description:
 *    Xscale cerf specific operations.
 */
#ifndef XSCALE_CERF_H
#define XSCALE_CERF_H

/* #define OTG_BIG_ENDIAN				1 */
#undef OTG_BIG_ENDIAN
#define OTG_DMA_DACK_ONLY				1
/* #undef OTG_DMA_DACK_ONLY */
#define OTG_DMA_DACK_ACTIVE_HIGH		1
/* #undef OTG_DMA_DACK_ACTIVE_HIGH */
#define OTG_DMA_DRQ_LEVEL_SENSITIVE		1
/* #undef OTG_DMA_DRQ_LEVEL_SENSITIVE	1 */
#define OTG_DMA_DRQ_ACTIVE_HIGH			1
/* #undef OTG_DMA_DRQ_ACTIVE_HIGH */
#define OTG_DMA_EOT_ACTIVE_HIGH			1
/* #undef OTG_DMA_EOT_ACTIVE_HIGH */
#define OTG_INT_ACTIVE_HIGH			1
//#undef OTG_INT_ACTIVE_HIGH
/* #define OTG_VBUS_SOURCE_EXTERNAL		1 */
#undef OTG_VBUS_SOURCE_EXTERNAL
#define OTG_SRP_VBUS_PULSE				1
/* #undef OTG_SRP_VBUS_PULSE */
/* #define OTG_EXTERNAL_PULLUP			1 */
#undef OTG_EXTERNAL_PULLUP

#ifdef CONFIG_XSCALE_CERF
#define OTG243_INT_LVL 41                  /* IRQ 41 */
#define OTG243_MEM_START PXA_CS3_PHYS      /* Physical address for CS3 */
#define OTG_16_BIT_DATA_BUS
#define OTG_ADJUST_TIMING

static inline int
RequestIrq
(
	unsigned int irq,
	void (*handler)(int, void *, struct pt_regs *),
	void *otg
)
{
	int gpio_irqpin;

	// find out pin number
	gpio_irqpin = IRQ_TO_GPIO_2_80(irq);
	// set direction register to input
	GPDR(gpio_irqpin) &= ~GPIO_bit(gpio_irqpin);

	// set gpio edge detect to rising edge
	set_GPIO_IRQ_edge(gpio_irqpin, GPIO_RISING_EDGE);

	info("RequestIrq: irq=%d gpio=%d", irq, gpio_irqpin);

	// attach ISR
	return OS_HookNonPCIInterruptVector(irq, handler, otg);
}

static inline void
ModifySpeed(void)
{
        UINT32 msc1;

        msc1 = MSC1 & 0x0000FFFF;
        MSC1 = msc1 | 0x15580000;
//        MSC1 = msc1 | 0x26680000;

	info("ModifySpeed: MSC1=%#x", MSC1);
}
#endif

#endif /* #ifndef XSCALE_CERF_H */
