/*
 * Copyright (C) 2002 TransDimension, Inc. All Rights Reserved
 * Copyright (C) 2003 Stephane Magnenat / ASL 2 / EPFL
 * Name: xscale_korebot.h
 * Author: Stephane Magnenat 5/9/03
 * Description:
 *    Xscale korebot specific operations.
 */
#ifndef XSCALE_KOREBOT_H
#define XSCALE_KOREBOT_H

// NB/TODO: Is that really clean??
#include <asm/arch/pxa-regs.h>
#include <asm/arch/hardware.h>
#include <asm/arch/irqs.h>

/* #define OTG_BIG_ENDIAN				1 */
#undef OTG_BIG_ENDIAN
#define OTG_DMA_DACK_ONLY				1
/*#undef OTG_DMA_DACK_ONLY */
#define OTG_DMA_DACK_ACTIVE_HIGH		1
/*#undef OTG_DMA_DACK_ACTIVE_HIGH */
#define OTG_DMA_DRQ_LEVEL_SENSITIVE		1
/*#undef OTG_DMA_DRQ_LEVEL_SENSITIVE */
#define OTG_DMA_DRQ_ACTIVE_HIGH			1
/* #undef OTG_DMA_DRQ_ACTIVE_HIGH */
#define OTG_DMA_EOT_ACTIVE_HIGH			1
/*#undef OTG_DMA_EOT_ACTIVE_HIGH */
#define OTG_INT_ACTIVE_HIGH			1
/*#undef OTG_INT_ACTIVE_HIGH*/
/* #define OTG_VBUS_SOURCE_EXTERNAL		1 */
#undef OTG_VBUS_SOURCE_EXTERNAL
#define OTG_SRP_VBUS_PULSE				1
/* #undef OTG_SRP_VBUS_PULSE */
/* #define OTG_EXTERNAL_PULLUP			1 */
#undef OTG_EXTERNAL_PULLUP

#ifdef CONFIG_XSCALE_KOREBOT
#define KOREBOT_USB_RST		33
#define KOREBOT_USB_WAKEUP	22
#define KOREBOT_USB_INT		3

#define OTG243_INT_LVL       IRQ_GPIO(KOREBOT_USB_INT)      
#define OTG243_MEM_START     PXA_CS1_PHYS     
#undef  OTG_16_BIT_DATA_BUS
#define OTG_ADJUST_TIMING

static inline void
HWReset(void)
{
  // Make sure the reset is high
  //GPSR(GPIO_bit(KOREBOT_USB_RST));
  GPSR1 |= GPIO_bit(KOREBOT_USB_RST);
  // set directions to output
  GPDR(KOREBOT_USB_RST) |= GPIO_bit(KOREBOT_USB_RST);
  //GPDR1 |= 2;
  
  // Same for the wakeup
  GPCR0 |= GPIO_bit(KOREBOT_USB_WAKEUP);
  GPDR(KOREBOT_USB_WAKEUP) |= GPIO_bit(KOREBOT_USB_WAKEUP);
  
#if 0
  //GPCR(GPIO_bit(KOREBOT_USB_RST));
  GPCR1 |= GPIO_bit(KOREBOT_USB_RST);
  udelay( 50 );
  //GPSR(GPIO_bit(KOREBOT_USB_RST));
  GPSR1 |= GPIO_bit(KOREBOT_USB_RST);
  udelay( 50 );
#endif
}

static inline int
RequestIrq
(
	unsigned int irq,
	irq_handler_t handler, //NB: was void (*handler)(int, void *, struct pt_regs *)
	void *otg
)
{
	//int gpio_irqpin;

	//NB: http://lists.arm.linux.org.uk/pipermail/linux-arm-kernel/2007-March/038626.html
	//NB: Done in request_irq, see os_intr.h (SA_TRIGGER_RISING)
	// find out pin number
	//gpio_irqpin = IRQ_TO_GPIO_2_80(irq);
	// set direction register to input
	//GPDR(gpio_irqpin) &= ~GPIO_bit(gpio_irqpin);
	// set gpio edge detect to rising edge
	//set_GPIO_IRQ_edge(gpio_irqpin, GPIO_RISING_EDGE);

	info("RequestIrq: irq=%d", irq);

	// attach ISR
	return OS_HookNonPCIInterruptVector(irq, handler, otg);
}

static inline void
ModifySpeed(void)
{
	UINT32 msc0;

	msc0 = MSC0 & 0x0000FFFF;
	//MSC0 = msc0 | 0xFFF40000;
	MSC0 = msc0 | 0x15500000;

	info("ModifySpeed: MSC0=%#x", MSC0);
}
#endif

#endif /* #ifndef XSCALE_KOREBOT_H */
